<!--
Copyright 2020 The Chromium Authors. All rights reserved.
Use of this source code is governed by a BSD-style license that can be
found in the LICENSE file.
-->

<!--
This file is used to generate a comprehensive list of Windows histograms
along with a detailed description for each histogram.

For best practices on writing histogram descriptions, see
https://chromium.googlesource.com/chromium/src.git/+/HEAD/tools/metrics/histograms/README.md

Please send CLs to chromium-metrics-reviews@google.com rather than to specific
individuals. These CLs will be automatically reassigned to a reviewer within
about 5 minutes. This approach helps the metrics team to load-balance incoming
reviews. Googlers can read more about this at go/gwsq-gerrit.
-->

<histogram-configuration>

<histograms>

<variants name="FileOperations">
  <variant name=".DeleteFile.NonRecursive" summary=""/>
  <variant name=".DeleteFile.Recursive" summary=""/>
</variants>

<histogram name="Windows.ApplockerRunning" enum="Boolean" expires_after="M83">
  <owner>forshaw@chromium.org</owner>
  <owner>wfh@chromium.org</owner>
  <summary>
    Records if the APPID driver is running which indicates Applocker is enabled
    and running. This does not guarantee that Applocker is configured to enforce
    any rules. Reported once per browser session, on startup.
  </summary>
</histogram>

<histogram name="Windows.CetAvailable" enum="BooleanAvailable"
    expires_after="2021-12-01">
  <owner>ajgo@chromium.org</owner>
  <owner>wfh@chromium.org</owner>
  <summary>
    Records if CET (Control-flow Enforcement Technology / Hardware Enforced
    Shadow Stack) is available, based on IsUserCetAvailableInEnvironment().
    Reported once per browser session, on startup.
  </summary>
</histogram>

<histogram name="Windows.ChromeDllPrefetchResult" enum="FilePrefetchResult"
    expires_after="2021-07-01">
  <owner>brucedawson@chromium.org</owner>
  <owner>jessemckenna@google.com</owner>
  <summary>
    The result of prefetching chrome.dll on Windows, including whether a
    fallback to slow prefetch took place, and why if so.
  </summary>
</histogram>

<histogram name="Windows.ComputeNativeWindowOcclusionTime" units="microseconds"
    expires_after="M83">
  <obsolete>
    Removed 11/2020. As of June 15, 2020, data indicates that computing
    occlusion is fast enough at all percentiles.
  </obsolete>
  <owner>fdoray@chromium.org</owner>
  <summary>
    The amount of CPU time a call to ComputeNativeWindowOcclusionStatus() takes.
  </summary>
</histogram>

<histogram name="Windows.FilesystemError{FileOperations}"
    enum="WinGetLastError" expires_after="M81">
  <owner>grt@chromium.org</owner>
  <summary>
    The Windows error code relating to a failed attempt to operate on a file or
    a directory. {FileOperations}
  </summary>
  <token key="FileOperations" variants="FileOperations">
    <variant name="">
      <obsolete>
        Base histogram. Use suffixes of this histogram instead.
      </obsolete>
    </variant>
  </token>
</histogram>

<histogram name="Windows.GetVersionExVersion" enum="WindowsVersion"
    expires_after="never">
  <obsolete>
    Removed 10/2020 as this histogram has been replaced by the synthetic
    histogram Windows.WindowsVersion generated from Windows.PatchLevel.
  </obsolete>
<!-- expires-never: Needed to measure Windows ecosystem. -->

  <owner>wfh@chromium.org</owner>
  <owner>brucedawson@chromium.org</owner>
  <summary>
    The Windows version (base::win::Version) as reported by GetVersionEx(). This
    is queried shortly after startup.
  </summary>
</histogram>

<histogram name="Windows.HasHighResolutionTimeTicks" enum="Boolean"
    expires_after="2021-06-13">
  <owner>brucedawson@chromium.org</owner>
  <owner>gab@chromium.org</owner>
  <summary>
    The value of TimeTicks::IsHighResolution(). Reported once per browser
    session, on startup.
  </summary>
</histogram>

<histogram name="Windows.HighResolutionTimerUsage" units="%"
    expires_after="M81">
  <owner>stanisc@chromium.org</owner>
  <summary>
    Percentage of elapsed time the high resolution timer is activated. The usage
    is reported by each of Chrome processes individually (without aggregation)
    and logged every 10 minutes.
  </summary>
</histogram>

<histogram name="Windows.HypervPresent" enum="BooleanEnabled"
    expires_after="2021-05-02">
  <owner>rkc@chromium.org</owner>
  <owner>rockot@chromium.org</owner>
  <summary>
    Whether Hyper-V is enabled on this machine. Logged shortly after startup.
    This metric will only be logged on Windows 10+.
  </summary>
</histogram>

<histogram name="Windows.InspectModule.ConnectionError"
    enum="BooleanConnectionError" expires_after="M81">
  <owner>pmonette@chromium.org</owner>
  <summary>
    Whether connection error has happened for the UtilWin service. Every time a
    connection is made to the service, a &quot;false&quot; value is reported to
    provide a baseline. Every time a mojo connection error happens, a
    &quot;true&quot; value is reported, which typically means the utility
    process crashed.
  </summary>
</histogram>

<histogram name="Windows.IsPinnedToTaskbar" enum="IsPinnedToTaskbarResult"
    expires_after="never">
<!-- expires-never: Used to assess Chrome usage on Windows -->

  <owner>markchang@google.com</owner>
  <owner>pmonette@chromium.org</owner>
  <summary>
    Indicates whether Chrome is pinned to the Windows taskbar for the current
    user. Recorded shortly after startup.
  </summary>
</histogram>

<histogram name="Windows.IsPinnedToTaskbar.ProcessError" enum="BooleanError"
    expires_after="M85">
  <owner>pmonette@chromium.org</owner>
  <summary>
    Indicates whether a connection error occured between the browser and the
    shell handler process. This is usually caused by a crash in the utility
    process. This is logged every time the pinned state is queried.
  </summary>
</histogram>

<histogram name="Windows.IsPinnedToTaskbar2" enum="BooleanError"
    expires_after="M87">
  <owner>pmonette@chromium.org</owner>
  <owner>chrdavis@microsoft.com</owner>
  <summary>
    Indicates whether Chrome is pinned to the Windows taskbar for the current
    user. Recorded shortly after startup. This is different from
    Windows.IsPinnedToTaskbar in that we do not check if the pin to taskbar verb
    is available on the shortcut and only relies on the shortcut existing in the
    User Pinned folder.
  </summary>
</histogram>

<histogram name="Windows.Kernel32Version" enum="WindowsVersion"
    expires_after="never">
  <obsolete>
    Removed 10/2020 as this histogram has been replaced by the synthetic
    histogram Windows.WindowsVersionKernel32 generated from
    Windows.PatchLevelKernel32.
  </obsolete>
<!-- expires-never: Needed to measure Windows ecosystem. -->

  <owner>wfh@chromium.org</owner>
  <owner>brucedawson@chromium.org</owner>
  <summary>
    The Windows version (base::win::Version) as reported by VerQueryValue() on
    kernel32.dll. This is queried shortly after startup.
  </summary>
</histogram>

<histogram name="Windows.ModuleInspector.ReadCacheResult"
    enum="InspectionResultsCacheReadResult" expires_after="M78">
  <owner>chrisha@chromium.org</owner>
  <owner>pmonette@chromium.org</owner>
  <summary>
    The result of reading the InspectionResultsCache from disk. The cache is
    read once at startup when the ModuleInspector needs it.
  </summary>
</histogram>

<histogram name="Windows.ModuleInspector.WriteCacheResult"
    enum="BooleanSuccess" expires_after="M78">
  <owner>chrisha@chromium.org</owner>
  <owner>pmonette@chromium.org</owner>
  <summary>
    The result of writing the InspectionResultsCache to disk. This is done every
    time the ModuleDatabase becomes idle.
  </summary>
</histogram>

<histogram name="Windows.NativeWindowVisibility{NativeWindowVisibility}"
    units="windows" expires_after="2021-02-01">
  <owner>davidbienvenu@chromium.org</owner>
  <owner>fdoray@chromium.org</owner>
  <summary>
    The number of Chrome browser windows in a given visibility state. This is
    computed using ComputeNativeWindowOcclusionStatus() and is recorded every 10
    minutes. {NativeWindowVisibility}
  </summary>
  <token key="NativeWindowVisibility">
    <variant name=""/>
    <variant name=".Hidden"
        summary="The native window is not visible because it is in a
                 minimized window"/>
    <variant name=".Occluded"
        summary="The native window is fully covered by other windows"/>
    <variant name=".Visible"
        summary="The native window is visible or partially visible."/>
  </token>
</histogram>

<histogram name="Windows.OOPSelectFileDialog.ProcessError" enum="BooleanError"
    expires_after="M82">
  <owner>pmonette@chromium.org</owner>
  <summary>
    Indicates whether a connection error occured between the browser and the
    shell handler process. This is usually caused by a crash in the utility
    process. This is logged every time SelectFile() function is called and the
    WinOOPSelectFileDialog feature is enabled.
  </summary>
</histogram>

<histogram name="Windows.ParentProcessNameHash" enum="ProcessNameHash"
    expires_after="never">
<!-- expires-never: Needed to measure third party incompatibilities on Windows which could happen at any time. -->

  <owner>wfh@chromium.org</owner>
  <owner>brucedawson@chromium.org</owner>
  <summary>
    The 32-bit hash of the lower-case parent process basename (e.g.
    explorer.exe) of the main Chrome executable. Reported once during startup as
    part of install verification.
  </summary>
</histogram>

<histogram name="Windows.PatchLevel" enum="WindowsPatchLevel"
    expires_after="never">
<!-- expires-never: Needed to measure Windows ecosystem. -->

  <owner>wfh@chromium.org</owner>
  <owner>brucedawson@chromium.org</owner>
  <summary>
    A 32-bit value formed from combining the minor and patch level of the
    currently running Windows operating system as reported by GetVersionEx().
    E.g. &quot;Windows 10 OS Version 1809 (Build 17763.503)&quot; would be 17763
    (0x4563), combined with 503 (0x1F7) = 0x456301F7. If either minor or patch
    level exceeds the value that can fit in a 16-bit unsigned integer, then this
    histogram will report 0. Reported once, shortly after browser startup.
  </summary>
</histogram>

<histogram name="Windows.PatchLevelKernel32" enum="WindowsPatchLevel"
    expires_after="never">
<!-- expires-never: Needed to measure Windows ecosystem. -->

  <owner>wfh@chromium.org</owner>
  <owner>brucedawson@chromium.org</owner>
  <summary>
    A 32-bit value formed from combining the minor and patch level of the
    currently running Windows operating system as reported by VerQueryValue() of
    kernel32.dll. E.g. &quot;Windows 10 OS Version 1809 (Build 17763.503)&quot;
    would be 17763 (0x4563), combined with 503 (0x1F7) = 0x456301F7. If either
    minor or patch level exceeds the value that can fit in a 16-bit unsigned
    integer, then this histogram will report 0. Reported once, shortly after
    browser startup.
  </summary>
</histogram>

<histogram name="Windows.PostOperationState{FileOperations}"
    enum="PostOperationState" expires_after="M81">
  <owner>grt@chromium.org</owner>
  <summary>
    The state of an item in the filesystem following an operation on it.
    {FileOperations}
  </summary>
  <token key="FileOperations" variants="FileOperations">
    <variant name="">
      <obsolete>
        Base histogram. Use suffixes of this histogram instead.
      </obsolete>
    </variant>
  </token>
</histogram>

<histogram name="Windows.ProcessorFamily" enum="ProcessorFamily"
    expires_after="2021-05-02">
  <owner>rkc@chromium.org</owner>
  <owner>rockot@chromium.org</owner>
  <summary>
    The processor family type. Logged shortly after startup. The value is
    specified in the SMBIOS specification, section 7.5.2:
    https://www.dmtf.org/sites/default/files/standards/documents/DSP0134_2.7.1.pdf
    This metric will only be logged on Windows 10+.
  </summary>
</histogram>

<histogram name="Windows.ProcessorVirtualizationFirmwareEnabled"
    enum="BooleanEnabled" expires_after="2021-05-02">
  <owner>rkc@chromium.org</owner>
  <owner>rockot@chromium.org</owner>
  <summary>
    Whether virtualization has been enabled in the system firmware. Logged
    shortly after startup. This metric will only be logged on Windows 10+.
  </summary>
</histogram>

<histogram name="Windows.Tablet" enum="BooleanTablet" expires_after="M77">
  <owner>zturner@chromium.org</owner>
  <summary>Count of browser launches from a Windows tablet pc.</summary>
</histogram>

<histogram name="Windows.TmpFileDeleter.FailCount" units="files"
    expires_after="2021-05-02">
  <owner>grt@chromium.org</owner>
  <owner>etiennep@chromium.org</owner>
  <summary>
    The number of files failed to be deleted in a single directory by the
    browser process's tmp file deleter on Windows. These are files that were
    left behind on previous runs when third-party software interfered with
    Chrome's ability to delete its own temporary files. No value is emitted for
    a directory if no delete attempts are made. Otherwise, the fail count will
    be zero or more.
  </summary>
</histogram>

<histogram name="Windows.TmpFileDeleter.SuccessCount" units="files"
    expires_after="2021-05-02">
  <owner>grt@chromium.org</owner>
  <owner>etiennep@chromium.org</owner>
  <summary>
    The number of files deleted in a single directory by the browser process's
    tmp file deleter on Windows. These are files that were left behind on
    previous runs when third-party software interfered with Chrome's ability to
    delete its own temporary files. No value is emitted for a directory if no
    delete attempts are made. Otherwise, the success count will be zero or more.
  </summary>
</histogram>

<histogram name="Windows.TouchDrag.Success" units="BooleanSuccess"
    expires_after="2021-03-01">
  <owner>davidbienvenu@chromium.org</owner>
  <owner>dfried@chromium.org</owner>
  <summary>
    Recorded each time the user starts a Windows touch drag drop of web
    contents. This is currently only used by the WebUI tab strip, where touch
    drag drop is enabled, to count the number of touch drags attempted.
    ::DoDragDrop occasionally blocks waiting for a right mouse button down
    followed by a move, which is detected by ::DoDragDrop not calling
    QueryContinueDrag for more than a second. This will be recorded as false.
    This stat will be used to determine how much of a real world problem this
    is.
  </summary>
</histogram>

</histograms>

</histogram-configuration>
